#!/usr/bin/perl

# Copyright (c) 1998 Gabor Egressy gabor@vmunix.com
# All rights reserved.  All wrongs reversed.  This program is free
# software; you can redistribute it and/or modify it under the same
# terms as Perl itself.

# Deeply modified by Carlo Rosa for the scopes of Claudio Panichi!
# Thanks!  ;-)


sub recurse($);

sub parse_word
  {
    my ($line) = shift(@_);
    $line =~ s/\r+|\n+|^\s+|\s+$//g ;
    return($line);
 }

sub excluded
 {
   my $dir = shift(@_);
   my $index = 0;
   while( $index < $#{@exclude_dir} +1 )
      {
        #print "\n $dir ---- $exclude_dir[$index]";
        return (1) if ($dir eq $exclude_dir[$index]);
        $index = $index + 1;
      }
   return (0);
 }

sub recurse($)
{
    my $dir = shift(@_);
     return if (excluded("$dir/"));

    opendir DIR,"$dir/"  or return;
    my @files = grep {!/^\.\.?$/} readdir DIR or return;
    closedir DIR;

    my ($dev,$ino) = (stat "$dir/")[0,1];
    $dir{"$dev-$ino"} = 1;

    my $file;
    for $file (@files)
       {
           ($dev,$ino) = (stat "$dir/$file")[0,1];
            if(-f _)
	        {
                    $suid{"$dir/$file"} = 1 if -u _ ;
		    $sgid{"$dir/$file"} = 1 if -g _;
                 }
           elsif(-d _ && ! exists $dir{"$dev-$ino"})
	        {
                    $suid{"$dir/$file/"} = 1 if -u _;
		   $sgid{"$dir/$file"} = 1 if -g _;
                   recurse "$dir/$file";
               }
       }
}


####################################################
####################### MAIN #######################
####################################################

open FILE, "./exclude_dir" or die"$!";
while ($line = <FILE> )
    {
       $line = parse_word($line);
       push (@exclude_dir,$line);
    }
close FILE;
recurse '';


open (FILE, ">./suid_files") or die "$!";
for (sort keys %suid)
   {
        print FILE "$_\n";
   }
close FILE;


open (FILE, ">./sgid_files") or die "$!";
for (sort keys %sgid)
   {
        print FILE "$_\n";
   }
close FILE;

